package com.acme;

import com.sun.grizzly.tcp.CompletionHandler;
import com.sun.grizzly.tcp.Response;
import com.sun.grizzly.tcp.http11.GrizzlyRequest;
import com.sun.grizzly.tcp.http11.GrizzlyResponse;
import com.sun.grizzly.util.buf.ByteChunk;

public class MyCompletionHandler
    implements CompletionHandler<Response>
{
    private static final byte[]  ERROR509 = "<html><body><h1>ERROR 509</h1></body></html>".getBytes();
    private static final int	ADAPTER_NOTES	= 31; //Comes from com.sun.grizzly.tcp.http11.GrizzlyAdapter
    
    @Override
    public void resumed( Response attachment )
    {
        complete( attachment );
    }

    @Override
    public void cancelled( Response attachment )
    {
        complete( attachment );
    }

    private void complete( Response res )
    {
        ByteChunk   chunk;
        
        try
        {
            // Default response in case of error
            if( res.getStatus() == 509 )
            {
                chunk = new ByteChunk();
                chunk.setBytes( ERROR509, 0, ERROR509.length );
                res.setContentLength( ERROR509.length );
                res.setContentType( "text/html" );
                res.sendHeaders();
                res.doWrite( chunk );
            }

            // Flush the response
            flushing( res );
        }
        catch( Exception ex )
        {
            System.err.println( "Error while completing the request" );
            ex.printStackTrace( System.err );
        }
    }

    private void flushing( Response res ) throws Exception
    {
        GrizzlyRequest  greq;
        GrizzlyResponse gres;

        greq = (GrizzlyRequest)res.getRequest().getNote( ADAPTER_NOTES );
        gres = (GrizzlyResponse)res.getNote( ADAPTER_NOTES );

        if( greq!=null && gres!=null )
        {
            gres.flushBuffer();
        }
        else
        {
            res.flush();
        }
    }
    
}
