package com.acme;

import com.sun.grizzly.tcp.Adapter;
import com.sun.grizzly.tcp.Request;
import com.sun.grizzly.tcp.Response;

public class MyExecutor implements Runnable
{
    private Request         req;
    private Response        res;
    private Adapter         adapter;

    public MyExecutor( Request req, Response res, Adapter adapter )
    {
        this.req = req;
        this.res = res;
        this.adapter = adapter;
    }

    @Override
    public void run()
    {
        try
        {
            adapter.service( req, res );
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
            res.setStatus( 500 );
            res.setMessage( "Error while performing service() in adapter" );
        }
        finally
        {
            resume();
        }
    }

    private void resume()
    {
        try
        {
            res.resume();
        }
        catch( Exception ex )
        {
            System.err.println( "Error while resuming the response" );
            ex.printStackTrace( System.err );
        }
    }
}
