package com.acme;

import com.sun.grizzly.tcp.http11.GrizzlyAdapter;
import com.sun.grizzly.tcp.http11.GrizzlyRequest;
import com.sun.grizzly.tcp.http11.GrizzlyResponse;
import java.io.OutputStream;

public class MyGrizzlyAdapter extends GrizzlyAdapter
{
    private static final int MAX_BUFFER_SIZE = 64 * 1024;

    private byte[]          buffer;
    private OutputStream    os;
    private boolean         rejected;

    
    public MyGrizzlyAdapter( boolean rejected )
    {
        this.buffer = new byte[MAX_BUFFER_SIZE];
        this.os = new NullOutputStream();
        this.rejected = rejected;
    }

    @Override
    public void service( GrizzlyRequest req, GrizzlyResponse res ) throws Exception
    {
        int read;

        if( rejected )
        {
            res.setStatus( 509, "[Grizzly] Sorry but I don't want to process it ! It's my choice !" );
        }
        else
        {
            while( (read=req.getStream().read(buffer))!=-1 )
            {
                os.write( buffer, 0, read );
            }

            // Simulate some more time consuming operation
            Thread.sleep( 1500 );

            // Respond
            res.setStatus( 200, "[Grizzly] Ok, Understand" );
        }
    }
    
    @Override
    public void afterService( GrizzlyRequest req, GrizzlyResponse res ) throws Exception
    {
        super.afterService( req, res );
    }
}
