package com.acme;

import java.io.IOException;
import java.io.OutputStream;

public class NullOutputStream extends OutputStream
{
    
    private boolean closed = false;

    @Override
    public void write(int b)
        throws IOException
    {
        if (closed) throw new IOException("Write to closed stream");
    }

    @Override
    public void write(byte[] data, int offset, int length)
        throws IOException
    {   
        if (data == null) throw new NullPointerException("data is null");
        if (closed) throw new IOException("Write to closed stream");

        // Simulate some time consuming operation
        try{ Thread.sleep( 1 ); } catch( Exception ex ) {}
    }

    @Override
    public void close()
    {
        closed = true;
    }

}

