package com.acme.test;

import java.io.File;
import java.util.concurrent.atomic.AtomicInteger;
import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpConnectionManager;
import org.apache.commons.httpclient.methods.FileRequestEntity;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.params.HttpMethodParams;

/**
 *
 */
public  class       Caller
        implements  Runnable
{
    private static final File FDATA = new File( "./target/test-classes/SomeData.data" );
    
    private String          url;
    private int             count;
    private AtomicInteger   succes;
    private AtomicInteger   busy;
    private HttpClient      client;

    public Caller( String url, int count, AtomicInteger succes, AtomicInteger busy, HttpConnectionManager cm )
    {
        this.url = url;
        this.count = count;
        this.succes = succes;
        this.busy = busy;
        this.client = new HttpClient( cm );
        //this.client.getHostConfiguration().setProxy( "localhost", 8888 );
    }

    @Override
    public void run()
    {
        int code;
        int i;
        PutMethod method = null;

        for( i=0; i<count; i++ )
        {
            try
            {
                method = new PutMethod( url );
                method.setContentChunked( true );
                method.setRequestEntity( createData() );
                method.getParams().setParameter( HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler(0,false) );
                code = client.executeMethod( method );
                if( code == 200 )
                {
                    succes.getAndIncrement();
                }
                else if( code == 509 )
                {
                    busy.getAndIncrement();
                }
                else
                {
                    System.out.println( "Error ("+i+") returning :"+code );
                }
            }
            catch( Exception ex )
            {
                System.out.println( "BAD :"+ex.getMessage() );
            }
            finally
            {
                method.releaseConnection();
                method = null;
            }
        }
    }

    private RequestEntity createData()
    {
        return new FileRequestEntity( FDATA, "application/data" );
    }
}
